Subject: Re: patch for problem with va-ppc.h included with egcs and gcc-2.95.2

From: Richard Henderson <[email-masked]>
Date: Wed, 1 Dec 1999 23:15:52 -0800

On Thu, Dec 02, 1999 at 12:20:06AM -0500, Jason Kim wrote:
> Well, xemacs-21.1.8, Mesa-3.0, gcc-2.95.2, xscreensaver-3.21, gle-2.3 and
> ssh-2.0.13 all compile and link against the older dynamic libraries, but
> use the va_list definition from my patch. All seem to work fine.

An interesting happy accident.  The PPC SVR4 ABI passes structures
by reference, which at the machine level winds up looking just like
it does when the array decomposes into a pointer.

> Anybody have any examples of where there IS va_list passage from user code to
> existing dynlib code (or vice versa)?

Of course -- vfprintf.

> If that is the case, then applying the patch en-mass
> seems harmless way for getting rid of the array based va_list once
> and for all.

Except that we're not going to do that.  We'll stay with the
letter of the PPC SVR4 ABI law, thanks. 

Despite what you may think, PPC is not unique in its use of an
array definition for va_list.  Whatever changes that might could
be made in gcc doesn't make the code in question any more correct
pedantically, and will continue to break when you go use someone
else's compiler.

r~

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/